Longest common substring | Dynamic programming

Поділитися
Вставка
  • Опубліковано 10 січ 2025

КОМЕНТАРІ •

  • @gourabbanerjee4152
    @gourabbanerjee4152 3 роки тому +31

    I believe I have gone through all the famous youtube channels explaining DSA. And I must say, the best explanation for each problem I find here. While I search for any problem, I have started looking whether TECH DOSE made any video on that or not, if yes, then I ignored all other channels blindly and I never disappointed. Thank you so much!!

    • @techdose4u
      @techdose4u  3 роки тому +1

      Welcome :)

    • @anaysha-family
      @anaysha-family 3 роки тому +1

      @@techdose4u I do the same, if I see a video from TECH DOSE I am done with my search.

    • @ravi7264
      @ravi7264 3 роки тому +1

      Same with me.

    • @udayptp
      @udayptp 3 роки тому

      @@ravi7264 🔥

  • @lakhwindersingh-qu6wj
    @lakhwindersingh-qu6wj 4 роки тому +26

    thank you tech dose. Finally someone explained this throughly

  • @Bhu22bhu22
    @Bhu22bhu22 3 роки тому +7

    Nothing can be better than this, you really wanted to make things clear, simply awesome man.
    Thank You and keep up the good work.

  • @AtulKumarVermaOnline
    @AtulKumarVermaOnline 3 роки тому +8

    Most UA-camrs just teach how it works and just go through the algorithm. Thank you for also teaching why it works and how to think about it.

  • @mariocraft95
    @mariocraft95 2 роки тому

    Was able to use this algorithm to finish a spell checker assignment. Could not have done it near as well without this video!

  • @jhilikkundu3158
    @jhilikkundu3158 3 роки тому +6

    Most underrated channel

  • @ashishm8850
    @ashishm8850 4 роки тому +6

    Dude, you have my respect, and my thanks! 🙏

  • @EngWorld-nr2ww
    @EngWorld-nr2ww 2 роки тому

    Nice and precise explanation than other available on youtube

  • @pavankumar.m1341
    @pavankumar.m1341 2 роки тому

    Now i understood the logic of this dynamic programming

  • @damaroro
    @damaroro 2 роки тому

    YOUR VIDEO HELPS ME A LOT, THANKS SENSEI

  • @atharvakulkarni2180
    @atharvakulkarni2180 2 роки тому +3

    Honestly, for beginners bottom up DP is not at all intuitive and your majority audience is beginner to medium level guys, so please try to explain DP problems using Top Down approach as well. BTW Very nice explanation. Thanks!

  • @atefnazi753
    @atefnazi753 3 роки тому +1

    very well explained...want more DP solutions from you

  • @prasad.patil12
    @prasad.patil12 4 роки тому +2

    Such a detailed and clear explanation 👍

  • @shagunlamba6481
    @shagunlamba6481 4 роки тому +3

    great explanation, recommending to everyone.

  • @SammyTvMan
    @SammyTvMan 3 роки тому +1

    Very well spoken, thank you

  • @geniusboys8204
    @geniusboys8204 4 роки тому +1

    great explanation ! Thank you finally I understood it.....

  • @where3639
    @where3639 3 роки тому +1

    Excellent video keep up the good work

  • @soulehshaikh8799
    @soulehshaikh8799 3 роки тому

    Easiest Explanation ever

  • @chiragkamat4887
    @chiragkamat4887 4 роки тому +1

    Very nicely explained. Thank you :)

  • @SZ-jw9my
    @SZ-jw9my 4 роки тому +1

    Excellent video, thank you!

  • @BharadwajGiridhar
    @BharadwajGiridhar 3 роки тому

    Nice channel. I love your content!

  • @bismeetsingh352
    @bismeetsingh352 4 роки тому

    @9:46 , why does the position even matter? Eg. s0 = "acdghr" s1 = "cdghra", cdghr are at different positions but that is a valid answer.

  • @PrateekJesingh
    @PrateekJesingh 4 роки тому

    Good explanation of the dynamic programming bit but what was lacking was the intuition behind how you filled the table, please include that as well. You wouldn't expect anyone to just memorise the solution

  • @shams_vai_360
    @shams_vai_360 7 місяців тому +1

    what is the difference between longest common subsequence and longest common substring?

  • @adityagoswami6881
    @adityagoswami6881 4 роки тому +3

    Can you explain after getting the all diagonal number in dp table ,how to print the lcs strings

    • @vemulacharanrayadhanush3110
      @vemulacharanrayadhanush3110 4 роки тому

      check this code
      int main() {
      int t;
      cin>>t;
      while(t--)
      {
      int n,m;
      cin>>n>>m;
      string s,s1;
      cin>>s>>s1;
      vector dp(n+1,vector(m+1,0));
      for(int i=1;i

  • @Pooh__7__
    @Pooh__7__ 3 роки тому +1

    Such an amazing video

  • @sreekanththota2200
    @sreekanththota2200 4 роки тому +2

    sir,I like your Great explanation .....

  • @adityapandey9639
    @adityapandey9639 3 роки тому +2

    What will be the recursive approach of this Q?? We can't return 0 if it's character is not matching!

    • @spartan5816
      @spartan5816 3 роки тому

      Watch aditya verma YT channel. Thank me later

    • @adityapandey9639
      @adityapandey9639 3 роки тому +1

      @@spartan5816 bhai I have already watched his video it was nice bt he used to spend more time in relating the Q rather than developing the concept.. Didn't worked well in my case 🙃

  • @prateeksrivastava9
    @prateeksrivastava9 5 років тому +5

    You made DP So Easy

  • @yanamanagandlabhargavi4577
    @yanamanagandlabhargavi4577 2 роки тому

    Great explanation

  • @sauravgsh16
    @sauravgsh16 5 років тому +2

    Great explanation. Can you also provide a space optimized solution for the same ?

    • @techdose4u
      @techdose4u  5 років тому

      Will try to....actually too many important requested videos are already pending. So, i want to focus on important topics for now 😅

    • @sauravgsh16
      @sauravgsh16 5 років тому

      @@techdose4u glad for the response .. will wait till you have time to upload one .. thanks ..

  • @vallishreddy8263
    @vallishreddy8263 4 роки тому +2

    good explanation

  • @ShaliniNegi24
    @ShaliniNegi24 4 роки тому +1

    thanks for the videos

  • @osmantahir8659
    @osmantahir8659 3 роки тому

    How to find a smallest number in the longest subsequence? in a dense subsequence. Dense subsequence means that the i+1 element should be less than or equal to 2 with the ith element in the subsequence

  • @AyushSingh-oq2fm
    @AyushSingh-oq2fm 3 роки тому +1

    does it have any recursive approach with memorisation??

    • @techdose4u
      @techdose4u  3 роки тому +1

      Yes it does

    • @AyushSingh-oq2fm
      @AyushSingh-oq2fm 3 роки тому

      Please provide it's link I am struggling to come up with it's recursive logic

  • @praveenchouhan6388
    @praveenchouhan6388 4 роки тому +1

    awesome explaination!!!!!!!!!!!!!! your way just super cool, thanks a lot!!!

  • @salmanfaries3064
    @salmanfaries3064 3 роки тому +1

    Would u have longest decreasing substring

    • @techdose4u
      @techdose4u  3 роки тому

      It's the same. Do LIS from the end.

  • @ankitaverma2271
    @ankitaverma2271 4 роки тому +3

    Can you please tell me about [i-1] =[j-1]
    Which index we are taking and how.?

    • @techdose4u
      @techdose4u  4 роки тому +2

      Because dp table is indexed from 1 (as index 0 in table means empty string) but the string position is always index from 0 (as index 0 means first character).

    • @ankitaverma2271
      @ankitaverma2271 4 роки тому +1

      @@techdose4u Thank youu.
      I got that.

    • @ankitaverma2271
      @ankitaverma2271 4 роки тому +1

      As in the example you explained of there js no match in the characters then mark the dp row coloumn as zero.
      Shouldn't we mark the max of row and coloumn??

    • @techdose4u
      @techdose4u  4 роки тому +2

      Max will be taken if we form subsequence where characters can be skipped but in this case you are matching substring, so whenever mismatch occurs, you cannot skip that character, you need to start from length 0 from the next character. This is the difference between subsequence and substring.

  • @parnitasharma8898
    @parnitasharma8898 4 роки тому +1

    Great job

  • @chessmaster856
    @chessmaster856 2 роки тому

    Start with 0 n-1, then 1 n-1, then 0 n-2 etc. Stop at the first palindrome. Everything else will be smaller so no need to check. No dp required

  • @andresnamm982
    @andresnamm982 3 роки тому +1

    You are awesome!

  • @ibrahimshaikh3642
    @ibrahimshaikh3642 4 роки тому

    Very good. Which whiteboard software u use

  • @supernova7870
    @supernova7870 4 роки тому +1

    Sir, do you have code for 0(N^3) approach , i solved it using 3 while loops , but the 3rd loop just execute for few statements , so i think its complexity is 0(N^2) .

    • @MrThepratik
      @MrThepratik 4 роки тому

      that would be average case time complexity

  • @shaziasamreen8584
    @shaziasamreen8584 4 роки тому

    Sir can't we use the string Matching method.Brute force approach is n*m and there are String Matching algorithms that reduce the complexity can't we use them with some manipulations and find the longest common substring

  • @RahulKumar-wf9xx
    @RahulKumar-wf9xx 4 роки тому

    What is the time complexity for the recursive Approach? is it O(2^(m+n)) ??

  • @bharathirv8479
    @bharathirv8479 4 роки тому

    Hi, The code returns less than one value from the actual length of substring, so I return the value +1 (return lcs+1) now it returns the correct length. are my findings correct?

  • @shubhamjaiswal7645
    @shubhamjaiswal7645 6 місяців тому

    explanation was good ...but what about memoization and recursion .... rather it would give TLE i know but you should firstly tell that n......

  • @sakthim7160
    @sakthim7160 5 років тому +1

    One character can't be string know? Then how you can say a single character as subject?Or did we can say a single character is a substring?

    • @techdose4u
      @techdose4u  5 років тому +1

      A single character is also a string actually. It's a string of length 1. Dont confuse with char and string datatypes. Think in general sense. A string can have no characters too (empty string).

    • @sakthim7160
      @sakthim7160 5 років тому +1

      @@techdose4u thank you

  • @sayantaniguha8519
    @sayantaniguha8519 3 роки тому

    Recursive solution?
    I don't care about TLE but need it for clear explanation

  • @impatientgaming9868
    @impatientgaming9868 Рік тому

    good one

  • @thatindianboy2817
    @thatindianboy2817 2 роки тому

    Any DFS Java solution?

  • @tejasghone5118
    @tejasghone5118 4 роки тому +1

    Great Explaination !! Can you do the unique path question from leetcode? qs-62

    • @techdose4u
      @techdose4u  4 роки тому

      Sure....I think I have already done. Don't remeber 😅 If not then I will do it in future.

    • @tejasghone5118
      @tejasghone5118 4 роки тому

      @@techdose4u no u haven't done that coz from last month whenever i get stuck on some qs I search for your videos first😂

    • @sayantaniguha8519
      @sayantaniguha8519 3 роки тому

      Link?

  • @suryakiran2970
    @suryakiran2970 Рік тому +1

    super

  • @sakthim7160
    @sakthim7160 5 років тому +2

    Why you are keeping all the elements as zero In the first row and column of a matrix? If any one of string doesn't contain any character, then we can simply say the result by using a single if conditions! And here 6x6 matrix is enough to perform what you have explained but why you are taking 7x7 matrix? Your space complexity is O(n1+1 * n2+1) complexity why? If I am using n1xn2 matrix that is 6x6 I have faced diagonal problem in matrix but I can solve it by putting a extra one condition! I want a explanation from your side kindly waiting for your reply! I think checking for the previous result that is previous diagonal only you are using the extra space

    • @techdose4u
      @techdose4u  5 років тому

      If condition is costlier. The if condition will be compared for each of the 36 cells. If you just fill it with 0 then time complexity is heavily improved. Think about 100 by 100 matrix. You will be comparing if for all 10000 cells while you can simply put 199 zeroes when you already know they will be zero. 2nd reason is to make the formula work seamlessly and reduce the code complexity. So you gain both in terms of TIME and CODE complexity. I have explained why it will be 0 by the way :)

    • @sakthim7160
      @sakthim7160 5 років тому +1

      @@techdose4u thanks for your explanation😍you are almost responding to all of my comments. Thank you

    • @techdose4u
      @techdose4u  5 років тому

      Welcome :)

  • @575saisri4
    @575saisri4 4 роки тому +1

    sir can u provide solutions of hackwithinfy round 1 2020 questions also plzz?

    • @techdose4u
      @techdose4u  4 роки тому

      I will try this weekend. Are the questions and editorials for the same are available?

    • @saisrisai9649
      @saisrisai9649 4 роки тому +1

      Yes sir.

    • @techdose4u
      @techdose4u  4 роки тому

      Okay...then I will try to find some time on weekend. But I can't guarantee.

  • @sais7065
    @sais7065 Рік тому +1

  • @coderpriyabrat3585
    @coderpriyabrat3585 3 роки тому +1

    💕💕💕💕💕💕💕💕💕💕

  • @huangCAnerd
    @huangCAnerd 2 роки тому

    Absolute insanity that this solution TLEs on CodeSignal.

  • @madhurjyadas1471
    @madhurjyadas1471 4 роки тому +2

    You stretch the video so long with some random unnecessary explanations.

    • @techdose4u
      @techdose4u  4 роки тому +8

      For some it may be unnecessary and for some it may be necessary. I explained assuming a beginner is watching. So people who already knows stuffs will feel its too long 😅 That's only my personal opinion though.

    • @sreekanththota2200
      @sreekanththota2200 4 роки тому +3

      @@techdose4u
      thats true bro....am a beginner

    • @ruthwang9177
      @ruthwang9177 4 роки тому +1

      @@techdose4u I find your explanation very helpful!

    • @techdose4u
      @techdose4u  4 роки тому

      Thanks

  • @petarulev6977
    @petarulev6977 2 роки тому +1

    very bad explanation